%define roundcubedir %{_datadir}/roundcubemail
Name: roundcubemail
Version:  0.1
Release:  0.5.beta2.2%{?dist}
Summary: Round Cube Webmail is a browser-based multilingual IMAP client

Group: Applications/System         
License: GPL        
URL: http://www.roundcube.net
Source0: roundcubemail-%{version}beta2.2.tar.gz
# roundcubemail contains GPL-incompatible licensed code that we cannot ship.  
# Therefore we use this script to remove the patented code before shipping it.
# Download the upstream tarball and invoke this script while in the
# tarball's directory:
# ./roundcubemail-generate-tarball.sh
Source1: roundcubemail.conf
Source2: roundcubemail.logrotate
Source3: roundcubemail-generate-tarball.sh

Source4: http://downloads.sourceforge.net/%{name}/roundcube_arabic-0.1-beta2.tar.gz
Source5: http://downloads.sourceforge.net/%{name}/roundcube_armenian-0.1-beta2.tar.gz
Source6: http://downloads.sourceforge.net/%{name}/roundcube_brazilian-0.1-beta2.tar.gz
Source7: http://downloads.sourceforge.net/%{name}/roundcube_catala-0.1-beta2.tar.gz
Source8: http://downloads.sourceforge.net/%{name}/roundcube_chinese-0.1-beta2.tar.gz
Source9: http://downloads.sourceforge.net/%{name}/roundcube_chinese-big5-0.1-beta2.tar.gz
Source10: http://downloads.sourceforge.net/%{name}/roundcube_czech-0.1-beta2.tar.gz
Source11: http://downloads.sourceforge.net/%{name}/roundcube_danish-0.1-beta2.tar.gz
Source12: http://downloads.sourceforge.net/%{name}/roundcube_dutch-0.1-beta2.tar.gz
Source13: http://downloads.sourceforge.net/%{name}/roundcube_estonian-0.1-beta2.tar.gz
Source14: http://downloads.sourceforge.net/%{name}/roundcube_hungarian-0.1-beta2.tar.gz
Source15: http://downloads.sourceforge.net/%{name}/roundcube_italiano-0.1-beta2.tar.gz
Source16: http://downloads.sourceforge.net/%{name}/roundcube_japanese-0.1-beta2.tar.gz
Source17: http://downloads.sourceforge.net/%{name}/roundcube_latvian-0.1-beta2.tar.gz
Source18: http://downloads.sourceforge.net/%{name}/roundcube_norwegian-0.1-beta2.tar.gz
Source19: http://downloads.sourceforge.net/%{name}/roundcube_polish-0.1-beta2.tar.gz
Source20: http://downloads.sourceforge.net/%{name}/roundcube_portuguese-0.1-beta2.tar.gz
Source21: http://downloads.sourceforge.net/%{name}/roundcube_romanian-0.1-beta2.tar.gz
Source22: http://downloads.sourceforge.net/%{name}/roundcube_russian-0.1-beta2.tar.gz
Source23: http://downloads.sourceforge.net/%{name}/roundcube_serbian-0-1-beta2.tar.gz
Source24: http://downloads.sourceforge.net/%{name}/roundcube_slovak-0.1-beta2.tar.gz
Source25: http://downloads.sourceforge.net/%{name}/roundcube_swedish-0.1-beta2.tar.gz
Source26: http://downloads.sourceforge.net/%{name}/roundcube_turkish-0.1-beta2.tar.gz
Source27: http://downloads.sourceforge.net/%{name}/roundcube_vietnamese-0.1-beta2.tar.gz

Source28: roundcubemail-README.fedora

BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root%(%{__id_u} -n)
Requires: php-pear-Auth-SASL
Requires: php-pear-DB
Requires: php-pear-Mail-Mime
Requires: php-pear-Net-SMTP
Requires: php-pear-Net-Socket
Requires: php, httpd

%description
RoundCube Webmail is a browser-based multilingual IMAP client
with an application-like user interface. It provides full
functionality you expect from an e-mail client, including MIME
support, address book, folder manipulation, message searching
and spell checking. RoundCube Webmail is written in PHP and 
requires the MySQL database or the PostgreSQL database. The user
interface is fully skinnable using XHTML and CSS 2.

%prep
%setup -q -n roundcubemail-0.1beta2
%setup -q -D -b4 -b5 -b6 -b7 -b8 -b9 -b10 -b11 -b12 -b13 -b14 -b15 -b16 -b17 -b18 -b19 -b20 -b21 -b22 -b23 -b24 -b25 -b26 -b27 -n roundcubemail-0.1beta2

# copy in language translations
for lang in am ar ca cn cz da et_EE hu it ja lv nb_NO nl_NL pl pt_BR pt_PT ro ru se sk sr tr tw vn; do
  cp -pr ../$lang program/localization
done

# fix permissions and remove any .htaccess files
find . -type f -print | xargs chmod a-x
find . -name \.htaccess -print | xargs rm -f

# fixup paths to use the right paths
sed -i 's|temp/|${_tmppath}|' config/main.inc.php.dist
sed -i 's|config/|%{_sysconfdir}/roundcubemail/|' config/main.inc.php.dist
sed -i 's|logs/|%{_logdir}/roundcubemail/|' config/main.inc.php.dist
sed -i 's|logs/|%{_logdir}/roundcubemail/|' program/include/main.inc
sed -i 's|config/|%{_sysconfdir}/roundcubemail/|' program/include/main.inc

# remove any reference to sqlite in config file so people don't mistakely
# assume it works
sed -i '/sqlite/d' config/db.inc.php.dist

%build

%install

rm -rf %{buildroot}
install -d %{buildroot}%{roundcubedir}
cp -pr * %{buildroot}%{roundcubedir}

mkdir -p %{buildroot}%{_sysconfdir}/httpd/conf.d
cp -pr %SOURCE1 %{buildroot}%{_sysconfdir}/httpd/conf.d

mkdir -p %{buildroot}%{_sysconfdir}/roundcubemail
mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d
cp -pr %SOURCE2 %{buildroot}%{_sysconfdir}/logrotate.d/roundcubemail

mkdir -p %{buildroot}/var/log/roundcubemail

cp -pr %SOURCE28 .

# use dist files as config files
mv %{buildroot}%{roundcubedir}/config/db.inc.php.dist %{buildroot}%{_sysconfdir}/roundcubemail/db.inc.php
mv %{buildroot}%{roundcubedir}/config/main.inc.php.dist %{buildroot}%{_sysconfdir}/roundcubemail/main.inc.php

# clean up the buildroot
rm -rf %{buildroot}%{roundcubedir}/{config,logs,temp}
rm -rf %{buildroot}%{roundcubedir}/{CHANGELOG,INSTALL,LICENSE,README,UPGRADING,SQL}

%clean
rm -rf %{buildroot}

%post
# replace default des string in config file for better security
function makedesstr
(
chars=(0 1 2 3 4 5 6 7 8 9 a b c d e f g h i j k l m n o p q r s t u v w x y z A
B C D E F G H I J K L M N O P Q R S T U V W X Y Z)

max=${#chars[*]}

for i in `seq 1 24`; do
    let rand=${RANDOM}%%${max}
    str="${str}${chars[$rand]}"
done
echo $str
)

sed -i "s/rcmail-\!24ByteDESkey\*Str/`makedesstr`/" /etc/roundcubemail/main.inc.php || : &> /dev/null
exit 0


%files
%defattr(-,root,root,-)
%doc CHANGELOG INSTALL LICENSE README UPGRADING SQL roundcubemail-README.fedora
%{roundcubedir}
%dir %{_sysconfdir}/%{name}
%attr(0640,root,apache) %config(noreplace) %{_sysconfdir}/%{name}/*
%config(noreplace) %{_sysconfdir}/httpd/conf.d/roundcubemail.conf
%attr(0775,root,apache) %dir /var/log/roundcubemail
%config(noreplace) %{_sysconfdir}/logrotate.d/roundcubemail

%changelog
* Mon May 14 2007 Jon Ciesla <limb@jcomserv.net> = 0.1-0.5.beta2.2
- Fixed source timestamps, added Russian langpack.
- Added logpath fix to main.inc.php
- Fixed logrotate filename.

* Fri May 11 2007 Jon Ciesla <limb@jcomserv.net> = 0.1-0.4.beta2.2
- Cleanup/elegantization of spec, .conf.

* Thu May 10 2007 Jon Ciesla <limb@jcomserv.net> = 0.1-0.3.beta2.2
- Fixed bad chars in script.

* Thu May 10 2007 Jon Ciesla <limb@jcomserv.net> = 0.1-0.2.beta2.2
- Added all langpacks.

* Thu May 10 2007 Jon Ciesla <limb@jcomserv.net> = 0.1-0.1.beta2.2
- Versioning fix.

* Wed May 09 2007 Jon Ciesla <limb@jcomserv.net> = 0.1-beta2.3
- Fixed generation of DES.
- Cleanup re patch.

* Mon May 07 2007 Jon Ciesla <limb@jcomserv.net> - 0.1-beta2.2.3
- Removed duplicate docs.
- Moved SQL to doc.
- Fixed perms on log dir, sysconfdir.
- Fixed Requires.  
- Fixed config.
- Fixed changelog spacing.
  
* Fri May 04 2007 Jon Ciesla <limb@jcomserv.net> - 0.1-beta2.2.2
- Created new source tarball with PEAR code removed. Added script for creation.

* Tue Feb 13 2007 Jon Ciesla <limb@jcomserv.net> - 0.1-beta2.2.1
- Excluded Portions from PEAR, included as dependancies
- Fixed log/temp issues, including logrotate

* Tue Jan 30 2007 Jon Ciesla <limb@jcomserv.net> - 0.1-beta2.2
- Initial packaging.
